#include <sys/stdtypes.h>
#include <malloc.h>
#include <stdio.h>
#include <string.h>


#include <sys/stdtypes.h>
#include <malloc.h>
extern void debugfree() ;
extern malloc_t debugmalloc() ;
extern char * debugstrdup() ;
extern char * sstrdup() ;

#define strdup( P1 ) debugstrdup( P1) 
#define malloc( P1) debugmalloc(P1) 
#define free( P1) debugfree(P1) 

void
debugfree( cp )
char * cp ;
{
	fprintf( stderr, "Freeing cp %p\n", cp ) ;
	if( !free(cp) )
	   fprintf( stderr, "FREE FAILED\n" ) ;

	return ;
}

malloc_t
debugmalloc( size )
size_t size ;
{
malloc_t	ptr ;

	ptr = (malloc_t)malloc( size ) ;
	
	fprintf( stderr,"malloc %p\n", ptr ) ;
	return( ptr ) ;
}

char *
debugstrdup( cp )
char * cp ;
{
char *	newcp ;

	newcp = (char *)strdup( cp ) ;
	fprintf( stderr,"strdup %p\n", newcp ) ;
	
	return( newcp ) ;
}

char *
sstrdup( cp )
char * cp ;
{
char *	newcp ;

	newcp = (char *)strdup( cp ) ;
	
	return( newcp ) ;
}
