/* bulkloadglobal.h */


/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */


#ifndef _bulkloadglobal_h
#define _bulkloadglobal_h

#define SMALLBUFLEN		256


#define INVALID_OPER_MODE		-1
#define NON_INTERACT_OPER_MODE		1
#define INTERACT_OPER_MODE		2

#define NON_INTERACTIVE_CHAR		'n'
#define INTERACTIVE_CHAR		'i'


#define FILE_MODE 1


#define EDITNOTOK			0
#define EDITSENDORIGTOPROBLEMSFILE 	1
#define	EDITSENDEDITTOPROBLEMSFILE 	2
#define EDITSENDORIGTONOACTFILE 	3
#define	EDITSENDEDITTONOACTFILE 	4
#define EDITEDITREPROCESS		5
#define EDITCONFIGFILE			6
#define EDITADDENTRYCONVTOADDVALUES	7
#define EDITROUTEINDIVATTRS		8
#define EDITHELPINFORMATION		9
#define EDITREEDITFILE			10
#define EDITOVERRIDE			11
#define EDITDISENABLEMINUSEFORENTRY	12

#define EDIT_SEND_ORIG_PROB_STR		"O\n"
#define EDIT_SEND_EDIT_PROB_STR		"E\n"
#define EDIT_SEND_ORIG_NOACT_STR	"ON"
#define EDIT_SEND_EDIT_NOACT_STR	"EN"
#define EDIT_PROCESS_EDIT_STR		"P\n"
#define EDIT_CONFIG_FILE_STR		"C\n"
#define EDIT_ADD_ENT_TO_ADD_VALS_STR	"V\n"
#define EDIT_ROUTE_INDIV_ATTRS_STR	"I\n"
#define EDIT_HELP_INFO_STR		"H\n"
#define EDIT_REEDIT_FILE_STR		"R\n"
#define EDIT_OVERRIDE			"D\n"
#define EDIT_DISENABLE_MINUS_E_STR	"X\n"

#define SEARCHNOTOK		0
#define SEARCHOK     		1
#define SEARCHABANDONED 	2
#define SEARCHFAILSECPROBLEM 	3
#define SEARCHFAILBINDPROBLEM	4

#define INDENTON 1
#define INDENTOFF 0

#define NUMBER_ALLOWED 1
#define NUMBER_NOT_ALLOWED 0

#define PERSON 1
#define ORGUNIT 2
#define ORG 3
#define LOCALITY 4
#define COUNTRY 5
#define MAXTYPE 5

#define NO_SELECTION			0
#define NONE_OF_THE_SELECTION		-1
#define QUIT_SELECTION			-2
#define EXTRA_SELECTION			-3

#define CREATE_OK	1
#define CREATE_NOTOK	0
#define CREATE_FATAL	-1

#define SEARCH_OK 	"ok"
#define SEARCH_ERROR 	"error"
#define SEARCH_FAIL 	"failed"

#define LIST_OK 	"ok"
#define LIST_ERROR 	"error"

#define READ_OK 	"ok"
#define READ_FAIL 	"failed"

#define QUERY_ERROR 1
#define NAME_PRINTED 2
#define LIST_PRINTED 3
#define NO_DEPT_FOUND 4
#define PARENT_PRINTED 5
#define NO_ORG_ENTERED 6
#define START_NEW_QUERY 7
#define NO_LOCALITY 8
#define NO_LOCALITY_SELECTED 9
#define NO_ORG_FOUND 10

#define SF_ABANDONED 1
#define SF_ACCRIGHT 2
#define SF_OPFAIL 3

/* this is used if a preject is returned.  Normally it is a give-up 
type of error, but it can mean that you are trying to look for
an invalid  2 letter country code */
#define PROTREJECT -2

#endif _bulkloadglobal_h
